#include "testlib.h"
#include <vector>

int main(int argc, char *argv[])
{
    setName("counts the number of < and >");
    registerTestlibCmd(argc, argv);

    //expected result
    int a = inf.readInt();
    int b = inf.readInt();
    int total = a + b + 1;

    //participants answer
    int ouf_less = 0;
    int ouf_greater = 0;

    //current and previous number
    int current;
    int previous;

    //checking if all numbers from 1 to a + b + 1
    //are in the output
    std::vector<bool> was(total + 1, false);
    bool is_permutation = true;

    for (int i = 0; i < total && is_permutation; i++)
    {
        current = ouf.readInt(1, total);
        if (was[current])
            is_permutation = false;
        was[current] = true;
        if (i)
        {
            if (previous < current)
                ouf_less++;
            else
                ouf_greater++;
        }
        previous = current;
    }

    if (!is_permutation)
        quitf(_pe, "the output sequence should be a permutation");
    if (!ouf.seekEof())
        quitf(_pe, "extra tokens in the output");

    if (ouf_less != a || ouf_greater != b)
        quitf(_wa, "expected %d '<' and %d '>', recieved %d '<' and %d '>'", a, b, ouf_less, ouf_greater);

    quitf(_ok, "expected %d '<' and %d '>', recieved %d '<' and %d '>'", a, b, ouf_less, ouf_greater);
}

