#include "testlib.h"

#include <vector>
#include <iostream>
using namespace std;

const int MAXN = 1001;

vector<int> nextMatrioshka(InStream &in)
{
	vector<int> v;
	string val;

	while (!in.seekEoln())
	{		
		v.push_back(in.readInt());		
	}
	return v;
}

int main(int argc, char *argv[])
{
	setName("compare two sets of matrioshka's");
	registerTestlibCmd(argc, argv);

	int ja = ans.readInt();
    int pa = ouf.readInt();
    ouf.nextLine();

    if (ja != pa)
        quitf(_wa, "expected %d, found %d", ja, pa);		

	int N;
	vector<int> v, z;

	N = inf.readInt();
	v.resize(MAXN);
	int x;
	for (int i = 0; i < N; i++)
	{
		x = inf.readInt();
		v[x]++;
	}

	z = v;

	for (int i = 0; i < pa; i++)
	{
		vector<int> q = nextMatrioshka(ouf);		

		for (int j = 0; j < (int)q.size(); j++)
		{
			if (!(1 <= q[j] && q[j] < MAXN))
				quitf(_wa, "expected value between 1 and %d, found %d", MAXN - 1, q[j]);										
		}

		for (int j = 1; j < (int)q.size(); j++)
		{
			if (q[j - 1] >= q[j])
				quitf(_wa, "expected increasing sequence of integers");
		}

		for (int j = 0; j < (int)q.size(); j++)
		{
			v[q[j]]--;
		}						
	}

	for (int i = 0; i < MAXN; i++)
	{
		if (v[i])
		{
			quitf(_wa, "expected number of matrioshka of type %d %d, found %d", i + 1, z[i], z[i] - v[i]);
		}
	}
	quitf(_ok, "%d matrioshka(s)", pa);
}